import type { ToRef } from 'vue-demi';
import type { QueryFunction, QueryKey, QueryObserver, QueryObserverOptions, QueryObserverResult } from '@tanstack/query-core';
import type { DeepUnwrapRef, MaybeRef, WithQueryClientKey } from './types';
import type { UseQueryOptions } from './useQuery';
import type { UseInfiniteQueryOptions } from './useInfiniteQuery';
export declare type UseQueryReturnType<TData, TError, Result = QueryObserverResult<TData, TError>> = {
    [K in keyof Result]: K extends 'fetchNextPage' | 'fetchPreviousPage' | 'refetch' | 'remove' ? Result[K] : ToRef<Readonly<Result>[K]>;
} & {
    suspense: () => Promise<Result>;
};
declare type UseQueryOptionsGeneric<TQueryFnData, TError, TData, TQueryKey extends QueryKey = QueryKey> = UseQueryOptions<TQueryFnData, TError, TData, TQueryKey> | UseInfiniteQueryOptions<TQueryFnData, TError, TData, TQueryKey>;
export declare function useBaseQuery<TQueryFnData, TError, TData, TQueryKey extends QueryKey>(Observer: typeof QueryObserver, arg1: MaybeRef<TQueryKey> | MaybeRef<UseQueryOptionsGeneric<TQueryFnData, TError, TData, TQueryKey>>, arg2?: MaybeRef<QueryFunction<TQueryFnData, DeepUnwrapRef<TQueryKey>>> | MaybeRef<UseQueryOptionsGeneric<TQueryFnData, TError, TData, TQueryKey>>, arg3?: MaybeRef<UseQueryOptionsGeneric<TQueryFnData, TError, TData, TQueryKey>>): UseQueryReturnType<TData, TError>;
export declare function parseQueryArgs<TQueryFnData = unknown, TError = unknown, TData = TQueryFnData, TQueryData = TQueryFnData, TQueryKey extends QueryKey = QueryKey>(arg1: MaybeRef<TQueryKey> | MaybeRef<UseQueryOptionsGeneric<TQueryFnData, TError, TData, TQueryKey>>, arg2?: MaybeRef<QueryFunction<TQueryFnData, DeepUnwrapRef<TQueryKey>>> | MaybeRef<UseQueryOptionsGeneric<TQueryFnData, TError, TData, TQueryKey>>, arg3?: MaybeRef<UseQueryOptionsGeneric<TQueryFnData, TError, TData, TQueryKey>>): WithQueryClientKey<QueryObserverOptions<TQueryFnData, TError, TData, TQueryData, TQueryKey>>;
export {};
//# sourceMappingURL=useBaseQuery.d.ts.map